/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: Module_monitor_instances.h 13753 2009-03-05 12:40:59Z jz $

#ifndef __MODULE_MONITTOR_INSTANCES_H
#define __MODULE_MONITTOR_INSTANCES_H

namespace sos {
namespace scheduler {

struct Module_monitors;
struct Module_monitor_instance;

//-------------------------------------------------------------------------Module_monitor_instances 

struct Module_monitor_instances : Object
{
                                Module_monitor_instances    ( Has_log* log, Module_monitors* );

    void                        close_instances             ();
    void                        clear_instances             ();
    void                        create_instances            ();
    void                        init                        ();
    void                    set_job_name                    ( const string& );
    void                    set_task_id                     ( int id );
    void                    set_log                         ( Has_log* );
    void                        attach_task                 ( Task*, Prefix_log* log );
    void                        detach_task                 ();
    void                        add_obj                     ( IDispatch*, const string& name );
    bool                        load                        ();
    Variant                     spooler_process_before      ();
    Variant                     spooler_process_after       ( Variant );
//
    bool                        is_empty                    ()                                      { return _instance_list.empty(); }
    Fill_zero                  _zero_;

  private:
    Module_monitors* const     _monitors;
    Delegated_log              _log;

    typedef std::list< ptr<Module_monitor_instance> >  Instance_list;
    Instance_list              _instance_list;
};

//-------------------------------------------------------------------------------------------------

} //namespace scheduler
} //namespace sos

#endif
