/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: include.h 13599 2008-07-04 09:11:54Z jz $        Joacim Zschimmer, Zschimmer GmbH, http://www.zschimmer.com

#ifndef __SCHEDULER_INCLUDE_H
#define __SCHEDULER_INCLUDE_H

namespace sos {
namespace scheduler {
namespace include { 

//----------------------------------------------------------------------------------Include_command

struct Include_command
{
                                Include_command             ( Scheduler*, const File_based*, const xml::Element_ptr&, const File_path& include_path );

    bool                        denotes_configuration_file  () const                                { return !_path.empty(); }
    File_path                   file_path                   () const                                { return _file_path; }
    Absolute_path               path                        () const                                { return _path; }
    string                      register_include_and_read_content( File_based* source_file_based );
    string                      read_content                ();
  //file::File_info*            file_info                   ();
    void                        initialize                  ();
    string                      obj_name                    () const;

  private:
    Fill_zero                  _zero_;
    File_path                  _attribute_file;
    File_path                  _attribute_live_file;
    Absolute_path              _path;                       // Mit Dateinamensendung
    File_path                  _file_path;
    ptr<file::File_info>       _file_info;
    const File_based*          _source_file_based;
    Spooler*                   _spooler;
    File_path                  _include_path;
    bool                       _is_initialized;
};

//-------------------------------------------------------------------------------------Has_includes
// Genderte inkludierte Dateien fhrt zum Erneuten Lesen des File_based

struct Has_includes             // <include live_file="..."> 
{
                                Has_includes                ();
    virtual                    ~Has_includes                ();


    xml::Element_ptr            dom_element                 ( const xml::Document_ptr&, const Show_what& );

  //virtual void                on_include_changed          ()                                      = 0;
    virtual Prefix_log*         log                         ()                                      = 0;
    virtual string              obj_name                    () const                                = 0;
    virtual Configuration_origin configuration_origin       () const                                = 0;
    virtual Spooler*            spooler                     () const                                = 0;

    bool                        has_includes                () const                                { return !_include_map.empty(); }
    void                        register_include            ( const Absolute_path&, file::File_info* );
  //void                        remove_include              ( const Absolute_path& );
    void                        remove_includes             ();
    file::File_info*            changed_included_file_info  ();
    
  private:
    typedef stdext::hash_map< string, ptr<file::File_info> >   Include_map;

    Fill_zero                  _zero_;
    Configuration*             _configuration;              // live/ oder cache/
    Include_map                _include_map;                // Path -> File_info
};

//---------------------------------------------------------------------------------Include_register

//struct Include_register : Object
//{
//                                Include_register            ();
//                               ~Include_register            ();
//
//    void                        register_include                 ( Has_includes*, const Absolute_path& );
//    void                        remove_include              ( Has_includes*, const Absolute_path& );
//    void                        check_files                 ( const directory_observer::Directory* );
//    void                        assert_no_has_includes      ( const Has_includes* );
//
//
//  private:
//    typedef stdext::hash_set< Has_includes* >   Has_includes_set;
//
//    struct Entry
//    {
//        ptr<file::File_info>   _file_info;
//        Has_includes_set       _has_includes_set;
//    };
//
//    typedef stdext::hash_map< string, Entry >   Include_map;
//
//
//    Fill_zero                  _zero_;
//    Include_map                _include_map;
//};

//-------------------------------------------------------------------------------------------------

} //namespace include
} //namespace scheduler
} //namespace sos

#endif
