/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// $Id: perl.h 11394 2005-04-03 08:30:29Z jz $    Joacim Zschimmer

#ifndef __Z_PERL_H
#define __Z_PERL_H

#include <list>
#include "z_com.h"
#include "perl_com.h"

namespace zschimmer
{

//void                            throw_perl              ( int perl_error );
string                          string_from_pv          ( SV* );

//---------------------------------------------------------------------------------------------Perl

struct Perl : Object
{
                                Perl                    ()                                          : _zero_(this+1) {}
                               ~Perl                    ();

    void                        init                    ();
    void                        close                   ();
    void                        parse                   ( const string& script_text, VARIANT* result = NULL );
    void                        start                   ( bool start_ = true );

    void                        eval                    ( const string& expression, VARIANT* result );
 //?Variant                     eval                    ( const string& expression )                { Variant result; eval( expression, &result ); return result; }
    

  //com::Variant                call                    ( const string& function_name );
  //com::Variant                call                    ( const string& function_name, const std::list<com::Variant>& par );
  //com::Variant                property_get            ( const string& property_name );
    void                        call                    ( const string& function_name, VARIANT* result );
    void                        call                    ( const string& function_name, const std::list<com::Variant>& par, VARIANT* result );
    void                        property_get            ( const string& property_name, VARIANT* result );
    void                        property_put            ( const string& property_name, const com::Variant& );
    string                      com_class_name          () const;

  private:
    static void                 xs_init                 ( PerlInterpreter* );
  //static void                 xs_init                 ();  // ohne MULTIPLICITY

    Fill_zero                  _zero_;
    void*                      _perl;
    bool                       _start;
    string                     _script;
};

//-------------------------------------------------------------------------------------------------

} //namespace zschimmer


#endif
